----------------------------------------------------
-- Description : unsync D-F/F for ripple counter
------------------------------------------
library ieee; use ieee.STD_LOGIC_1164.all;

entity  DFFU  is
	port(CLK,D,R : in std_logic;
	     Q,QN:out std_logic);
end DFFU;

------------------------------------------
architecture  RTL  of  DFFU  is
signal Q_IN : std_logic;
begin
	QN <= not Q_IN;
	Q  <= Q_IN;
	process(CLK) begin
         if(R='1') then
			Q_IN<='0';
		elsif(CLK'event and CLK='1') then
			Q_IN <= D;
		end if;
	end process;
end RTL;

------------------------------------------
library ieee; use ieee.STD_LOGIC_1164.all;

entity  RIP is
  port( clk0,rst : in std_logic;
           clkn  : out std_logic_vector(15 downto 0) );
end;
-----------------------------------------
architecture  RTL  of  RIP  is

component DFFU
	port(CLK,D,R : in std_logic;
           Q,QN:out std_logic);
end component;

signal cnt : std_logic_vector(16 downto 0);

begin
  cnt(0) <= clk0;
  GEN1: for I in 0 to 15 generate
    U: DFFU port map(cnt(I),cnt(I+1),rst,clkn(I),cnt(I+1));
  end generate;
end RTL;
